################################################################################
########################### Censored T Mixed Models ############################
################################################################################

## Nonlinear case ##

###############################
## Influence analysis ##
###############################

## GD ##

CD<-function(cc,y,x,nj,beta1,sigmae,xi,zi,tui,tubi,tubbi,tuybi,tuyi,tuyyi,D1,MatrizQ,MatrizQbeta,MatrizQsigmae,MatrizQalpha){
    
  m<-length(nj)
  N<-sum(nj)
    
  iD1<-solve(D1)
    
  u<-tui
  uy<-tuyi
  uyy<-tuyyi
  ub<-tubi
  ubb<-tubbi
  uyb<-tuybi
  X<-xi
  z<-zi
  
  q1<-dim(D1)[2]
  p<-length(beta1)
  
  dx<-as.vector(c(D1[1,1],D1[1,2],D1[2,2]))
  theta<-c(t(beta1),sigmae,dx)

  GD<-rep(0,m);GDbeta<-rep(0,m);GDsigmae<-rep(0,m);GDalpha<-rep(0,m)

  for (j in 1:m){

      u1<-tui[j]
      uyy1<-matrix(uyy[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), (sum(nj[1:j-1])+1) : (sum(nj[1:j]))],nj[j],nj[j])
      uy1<-matrix(uy[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), j],nj[j],1)
      uyb1<-matrix(uyb[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), (((j-1)*q1)+1) : (j*q1)] ,nj[j],q1)
      ub1<-matrix(ub[(((j-1)*q1)+1) : (j*q1), j],q1,1)
      ubb1<-matrix(ubb[(((j-1)*q1)+1) : (j*q1), (((j-1)*q1)+1) : (j*q1)],q1,q1)
      z1<-matrix(z[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), (((j-1)*q1)+1) : (j*q1)],nj[j],q1)
      x1<-matrix(X[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), (((j-1)*p)+1) : (j*p)],nj[j],p)

      gammai=x1%*%beta1
      Psi<-(sigmae*diag(nj[j])+(z1)%*%D1%*%t(z1))

    derbeta<-(1/sigmae)*(t(x1)%*%(uy1-z1%*%ub1-u1*(x1%*%beta1)))
    dersigmae<-(-0.5)*(((1/sigmae)*nj[j])-(((1/sigmae)^2)*(sum(diag(uyy1))-t(uy1)%*%gammai-t(gammai)%*%uy1-sum(diag(t(uyb1)%*%z1))-sum(diag(uyb1%*%t(z1)))
                  +t(gammai)%*%z1%*%ub1+t(ub1)%*%t(z1)%*%gammai+u1*(t(gammai)%*%gammai)+sum(diag(ubb1%*%t(z1)%*%z1)))))

      d1<-matrix(rep(0,4),ncol=2,nrow=2);d1[1,1]<-1
      d2<-matrix(rep(0,4),ncol=2,nrow=2);d2[1,2]<-1;d2[2,1]<-1
      d3<-matrix(rep(0,4),ncol=2,nrow=2);d3[2,2]<-1
      
      d<-list(d1,d2,d3)
      
      deralpha<-rep(0,3)
      for(i in 1:3){
          di<-d[[i]]
          deralpha[i]<-(-0.5)*sum(diag(iD1%*%di-iD1%*%di%*%iD1*ubb1))   
        }

    derthetai<-matrix(c(t(derbeta),dersigmae,deralpha),nrow=(p+1+3),ncol=1)
    thetai<-theta-(solve((-1*MatrizQ))%*%(derthetai))

    thetabeta<- theta[1:p]; thetabetai<- thetai[1:p]
    thetasigmae<-theta[p+1]; thetasigmaei<-thetai[p+1]
    thetaalpha<-theta[(p+2):(p+1+3)]; thetaalphai<-thetai[(p+2):(p+1+3)]

    GD[j]<-t(theta-thetai)%*%(-1*MatrizQ)%*%(theta-thetai)
    GDbeta[j]<-t(thetabeta-thetabetai)%*%(-1*MatrizQbeta)%*%(thetabeta-thetabetai)
    GDsigmae[j]<-t(thetasigmae-thetasigmaei)%*%(-1*MatrizQsigmae)%*%(thetasigmae-thetasigmaei)
    GDalpha[j]<-t(thetaalpha-thetaalphai)%*%(-1*MatrizQalpha)%*%(thetaalpha-thetaalphai)

    }

   obj.out<-list(GD = GD, GDbeta = GDbeta ,GDsigmae = GDsigmae ,GDalpha = GDalpha)

  return(obj.out)

}

If<-function(cc,y,x,nj,beta1,sigmae,xi,zi,tui,tubi,tubbi,tuybi,tuyi,tuyyi,D1,MatrizQ,MatrizQbeta,MatrizQsigmae,MatrizQalpha,Perturb){
  
  ## Perturb==1 - Case weight perturbation
  ## Perturb==2 - Scale matrix perturbation - perturbation on D
  ## Perturb==3 - Scale matrix perturbation - perturbation on sigmae
  ## Perturb==4 - Response perturbation
  
  m<-length(nj)
  N<-sum(nj)
  
  iD1<-solve(D1)
  
  u<-tui
  uy<-tuyi
  uyy<-tuyyi
  ub<-tubi
  ubb<-tubbi
  uyb<-tuybi
  X<-xi
  z<-zi
  
  q1<-dim(D1)[2]
  p<-length(beta1)
    
  mdelta<-matrix(0,(p+1+3),m)
  
  for (j in 1:m ){
    
    u1<-tui[j]
    uyy1<-matrix(uyy[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), (sum(nj[1:j-1])+1) : (sum(nj[1:j]))],nj[j],nj[j])
    uy1<-matrix(uy[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), j],nj[j],1)
    uyb1<-matrix(uyb[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), (((j-1)*q1)+1) : (j*q1)] ,nj[j],q1)
    ub1<-matrix(ub[(((j-1)*q1)+1) : (j*q1), j],q1,1)
    ubb1<-matrix(ubb[(((j-1)*q1)+1) : (j*q1), (((j-1)*q1)+1) : (j*q1)],q1,q1)
    z1<-matrix(z[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), (((j-1)*q1)+1) : (j*q1)],nj[j],q1)
    x1<-matrix(X[(sum(nj[1:j-1])+1) : (sum(nj[1:j])), (((j-1)*p)+1) : (j*p)],nj[j],p)
    
    gammai=x1%*%beta1
    Psi<-(sigmae*diag(nj[j])+(z1)%*%D1%*%t(z1))
    
    si<-rep(1,nj[j])
    
    if(Perturb==1){
      
      delta1<-(1/sigmae)*(t(x1)%*%(uy1-z1%*%ub1-u1*x1%*%beta1))
      delta2<-(-0.5)*(((1/sigmae)*nj[j])-(((1/sigmae)^2)*(sum(diag(uyy1))-t(uy1)%*%gammai-t(gammai)%*%uy1-sum(diag(t(uyb1)%*%z1))-sum(diag(uyb1%*%t(z1)))
                                                          +t(gammai)%*%z1%*%ub1+t(ub1)%*%t(z1)%*%gammai+u1*t(gammai)%*%gammai+sum(diag(ubb1%*%t(z1)%*%z1)))))
      
      d1<-matrix(rep(0,4),ncol=2,nrow=2);d1[1,1]<-1
      d2<-matrix(rep(0,4),ncol=2,nrow=2);d2[1,2]<-1;d2[2,1]<-1
      d3<-matrix(rep(0,4),ncol=2,nrow=2);d3[2,2]<-1
      
      d<-list(d1,d2,d3)
      
      deralphaw<-rep(0,3)
      for(i in 1:3){
        di<-d[[i]]
        deralphaw[i]<-(-0.5)*sum(diag(iD1%*%di-iD1%*%di%*%iD1*ubb1))   
      }
      
      mdelta[,j]<-c(delta1,delta2,deralphaw)
      
    }
    
    if(Perturb==2){
      
      delta1<-rep(0,p)
      delta2<-0 
      
    
      d1<-matrix(rep(0,4),ncol=2,nrow=2);d1[1,1]<-1
      d2<-matrix(rep(0,4),ncol=2,nrow=2);d2[1,2]<-1;d2[2,1]<-1
      d3<-matrix(rep(0,4),ncol=2,nrow=2);d3[2,2]<-1
      
      d<-list(d1,d2,d3)
      
      deralphaw<-rep(0,3)
      for(i in 1:3){
        di<-d[[i]]
        deralphaw[i]<-(0.5)*sum(diag(iD1%*%di%*%iD1*ubb1))   
      }
      
      mdelta[,j]<-c(delta1,delta2,deralphaw)
      
    }
    
    if(Perturb==3){
      
      delta1<-(1/sigmae)*(t(x1)%*%(uy1-z1%*%ub1-u1*x1%*%beta1)) 
      delta2<- (0.5)*(((1/sigmae)^2)*(sum(diag(uyy1))-t(uy1)%*%gammai-t(gammai)%*%uy1-sum(diag(t(uyb1)%*%z1))-sum(diag(uyb1%*%t(z1)))
                                      +t(gammai)%*%z1%*%ub1+t(ub1)%*%t(z1)%*%gammai+u1*t(gammai)%*%gammai+sum(diag(ubb1%*%t(z1)%*%z1))))
      
      deralphaw<-rep(0,3)
      
      mdelta[,j]<-c(delta1,delta2,deralphaw)
      
    }
    
    if(Perturb==4){

      delta1<-(-1/sigmae)*(t(x1)%*%si*u1) 
      delta2<- (0.5/(sigmae)^2)*((-sum(diag(uy1%*%t(si) + si%*%t(uy1)))+t(gammai)%*%(si*u1) + sum(diag(si%*%t(ub1)%*%t(z1)))
                                   +t(si*u1)%*%gammai + sum(diag(ub1%*%t(si)%*%z1)))) 
      
      deralphaw<-rep(0,3)
      
      mdelta[,j]<-c(delta1,delta2,deralphaw)      
    }
    
  }
  
  If<-t(mdelta)%*%solve(MatrizQ)%*%mdelta
  
  return(If)
  
}










